Bug 209457 - shells/ksh93 does not build on ARM
Summary: shells/ksh93 does not build on ARM
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: arm Any
: --- Affects Some People
Assignee: Sunpoet Po-Chuan Hsieh
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2016-05-11 17:52 UTC by Ulrich Grey
Modified: 2016-10-28 15:09 UTC (History)
1 user (show)

See Also:
bugzilla: maintainer-feedback? (sunpoet)


Attachments
poudriere shells/ksh93 build log (132.79 KB, application/x-gzip)
2016-05-11 17:55 UTC, Ulrich Grey
no flags Details
shells/ksh93 successful build on ARM log (130.23 KB, application/x-gzip)
2016-05-12 19:58 UTC, Ulrich Grey
no flags Details
armv6 fix (2.34 KB, patch)
2016-10-22 16:35 UTC, Mikael Urankar
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Ulrich Grey 2016-05-11 17:52:27 UTC
(00:59:56) ===>  Staging for ksh93-20120801_2
(00:59:58) ===>   Generating temporary packing list
(00:59:58) install  -s -m 555 /wrkdirs/usr/ports/shells/ksh93/work/ksh93-20120801_2/bin/ksh /wrkdirs/usr/ports/shells/ksh93/work/stage/usr/local/bin/ksh93
(00:59:58) install: /wrkdirs/usr/ports/shells/ksh93/work/ksh93-20120801_2/bin/ksh: No such file or directory
(00:59:58) *** Error code 71
(00:59:58) 
(00:59:58) Stop.
(00:59:58) make: stopped in /usr/ports/shells/ksh93

Please see attached build log.
Comment 1 Ulrich Grey 2016-05-11 17:55:05 UTC
Created attachment 170219 [details]
poudriere shells/ksh93 build log
Comment 2 Mikael Urankar freebsd_committer 2016-05-12 11:40:33 UTC
It will build fine if you remove files/patch-src-lib-libast-hash-hashalloc.c and files/patch-src-lib-libast-string-tokscan.c
Comment 3 Ulrich Grey 2016-05-12 19:58:42 UTC
Created attachment 170234 [details]
shells/ksh93 successful build on ARM log

After removing the mentioned patches the build finished successfully.
Now I try to compile CDE.
Thank you for advice.
Comment 4 Ulrich Grey 2016-05-12 20:27:59 UTC
Building CDE on ARM delivers this error:

Building Release 2.2.3 of CDE
...
make -f xmakefile   VerifyOS

Building on FreeBSD 11.0-CURRENT arm.

make -f xmakefile   Makefiles
making Makefiles in config...
...skipping...
3 warnings and 3 errors generated.
*** exit code 1 making cmdinit.o
ksh93 requires libcmd but libcmd had build errors
build libAST 930519
Comment 5 Ulrich Grey 2016-05-26 08:12:44 UTC
(In reply to Ulrich Grey from comment #4)
Mikaël Urankar has provided some patches for building CDE.
Applying these patches CDE builds well.
There are no more errors.
shells/ksh93 now works well for building CDE Desktop.
Comment 6 Mikael Urankar freebsd_committer 2016-10-22 16:35:56 UTC
Created attachment 176064 [details]
armv6 fix

Hi,
Can we fix this issue? The problem was introduced in bug #185256
Using the upstream patch allows ksh93 to build on armv6 and 10.3/11.0 i386

see:
https://github.com/att/ast/blob/beta/src/lib/libast/string/tokscan.c#L245
https://github.com/att/ast/blob/beta/src/lib/libast/hash/hashalloc.c#L154

thanks in advance.
Comment 7 commit-hook freebsd_committer 2016-10-28 15:09:04 UTC
A commit references this bug:

Author: sunpoet
Date: Fri Oct 28 15:08:15 UTC 2016
New revision: 424858
URL: https://svnweb.freebsd.org/changeset/ports/424858

Log:
  - Fix build on armv6
  - While I'm here, fix diff header of patch file

  PR:		209457
  Submitted by:	<mikael.urankar@gmail.com>
  Obtained from:	https://github.com/att/ast/blob/beta/src/lib/libast/hash/hashalloc.c
  		https://github.com/att/ast/blob/beta/src/lib/libast/string/tokscan.c

Changes:
  head/shells/ksh93/files/patch-src-lib-libast-features-wchar
  head/shells/ksh93/files/patch-src-lib-libast-hash-hashalloc.c
  head/shells/ksh93/files/patch-src-lib-libast-string-tokscan.c
Comment 8 Sunpoet Po-Chuan Hsieh freebsd_committer 2016-10-28 15:09:43 UTC
Committed. Thanks!